#sccs	"@(#)uts/kern/sys:systm.h	1.2"

/*	Convergent Technologies - System V - May 1983	*/

#ifndef systm_h
#define systm_h

#include <sys/param.h>
#include <sys/inode.h>
#include <sys/proc.h>
#include <sys/pte.h>
#include <sys/buf.h>
#include <sys/file.h>
#include <sys/filsys.h>
#include <sys/cmap.h>

/*
 * Random set of variables used by more than one routine.
 */
extern int nofile;		/* number of files */

extern struct inode *rootdir;	/* pointer to inode of root directory */
extern short cputype;		/* type of cpu = 1	MegaFrame
						 2	MegaFrame2 (MiniFrame)
				 */
extern time_t lbolt;		/* time in HZ since last boot */
extern time_t time;		/* time in sec from 1970 */

extern char runin;		/* scheduling flag */
extern char runout;		/* scheduling flag */
extern int runrun;		/* scheduling flag */
extern char curpri;		/* current priority */
extern struct proc *curproc;	/* current proc */
extern struct proc *curmapproc;	/* current proc loaded in memory map */
extern struct proc *runq;	/* head of linked list of running processes */

extern	maxmem;			/* max available memory */
extern	physmem;		/* physical memory on this CPU */
extern	nswap;			/* size of swap space */
extern dev_t rootdev;		/* device of the root */
extern dev_t swapdev;		/* swapping device */
extern dev_t pipedev;		/* pipe device */
extern char *panicstr;		/* panic string pointer */
extern	blkacty;		/* active block devices */

extern dev_t getmdev();
extern daddr_t	bmap();
extern struct inode *ialloc();
extern struct inode *iget();
extern struct inode *owner();
extern struct inode *maknode();
extern struct inode *namei();
extern struct buf *alloc();
extern struct buf *getblk();
extern struct buf *geteblk();
extern struct buf *bread();
extern struct buf *breada();
extern struct filsys *getfs();
extern struct file *getf();
extern struct file *falloc();
extern int	uchar();

/*
 * Structure of the system-entry table
 */
extern struct sysent {
	char	sy_narg;		/* total number of arguments */
	int	(*sy_call)();		/* handler */
} sysent[];

extern struct buf *baddr();
extern void bcopy();
extern int copyin();
extern int copyout();
extern int copyseg();
extern int clearseg();
extern unsigned max();
extern void mclear();
extern int memall();
extern struct cmap *mfind();
extern unsigned min();
extern int schar();
extern swblk_t vtod();
extern struct pte *vtohpte();
extern struct mpte *vtopte();
#endif systm_h
